*** Settings ***
Documentation  callcenter_callreports_v1_fun1.robot
...            case link: xxxxxx
...            use command: robot -d xxx -T callcenter_callreports_v1_fun1.robot
...            description: funcation description info
...            author: xxxxxx
...            min support version: xxxxxx
...            technology area: 智客
...            sub-area: 呼叫中心
...            Case List :
...                Tc1: case1 info detail description
...                Tc2: case2 info detail description
...                Tc3: case3 info detail description


Resource    ${EXECDIR}/keyword/common_keywords_set.robot
#Resource    ${EXECDIR}/keyword/call_center_keyword.robot
Resource    ${EXECDIR}/callcenter_callreports_v1_setup_teardown.robot


Suite Setup       Run Keywords    My Suite Setup
Test Setup        Run Keywords    My Test Setup
#Test Teardown     Run Keywords    My Test Teardown
#Suite Teardown    Run Keywords    My Suite Teardown

#*********************************************************************
*** Variables ***


#*********************************************************************
*** Test Cases ***

Tc0 debug case
    [Documentation]
    ...    - xxxxxx
    ...    - xxxxxx
    ...    - xxxxxx

    [Tags]    Sanity    0    1

    Log    ---------- Tc1 step: ok ok ok ------------    console=True
	

Tc1 Test basic function under call reports of call center 
    [Documentation]
    ...    -  进入呼叫中心
    ...    -  进入呼叫中心 > 通话记录
    ...    -  手工输入起始和结束日期和时间
    ...    -  下拉菜单单选
    ...    -  下拉菜单多选

    [Tags]    Sanity    1    呼叫中心

    Log    ---------- Tc1 step 1: 进入呼叫中心 ------------    console=True
    Click Link    ${locator_vars}[呼叫中心]

    Log    ---------- Tc1 step 2: 进入呼叫中心 > 通话记录 ------------    console=True
    Wait Until Page Contains    记录    60s
	Click Element    ${locator_vars}[呼叫中心_通话记录]
    Wait Until Page Contains    通话记录    60s

    #Write Url And Session Into File

    Log    ---------- Tc1 step 3: 手工输入起始和结束日期和时间 ------------    console=True
    Set Calendar From Start To End By Input Date And Time
    ...    clear_locator=${locator_vars}[通话记录_日期控件_时间清除]
    ...    calendar_locator=${locator_vars}[通话记录_日期控件_选中]
    ...    start_locator=${locator_vars}[通话记录_日期控件_开始日期位置]
    ...    end_locator=${locator_vars}[通话记录_日期控件_结束日期位置]
    ...    input_start_date_and_time=2011-01-01 00:00
    ...    input_end_date_and_time=2018-01-01 00:00
    ...    commit_locator=${locator_vars}[通话记录_日期控件_确定]

    Log    ---------- Tc1 step 4: 下拉菜单单选 ------------    console=True
    Select Single Item From Dropdown List    dl_locator=${locator_vars}[呼叫方向_下拉框选中]    item_locator=${locator_vars}[呼叫方向_呼出]
    Select Single Item From Dropdown List    dl_locator=${locator_vars}[呼叫方向_下拉框选中]    item_locator=${locator_vars}[呼叫方向_呼入]
    Select Single Item From Dropdown List    dl_locator=${locator_vars}[呼叫方向_下拉框选中]    item_locator=${locator_vars}[呼叫方向_全部方向]

    Select Single Item From Dropdown List    dl_locator=${locator_vars}[接听状态_下拉框选中]    item_locator=${locator_vars}[接听状态_未接听]
    Select Single Item From Dropdown List    dl_locator=${locator_vars}[接听状态_下拉框选中]    item_locator=${locator_vars}[接听状态_已接听]
    Select Single Item From Dropdown List    dl_locator=${locator_vars}[接听状态_下拉框选中]    item_locator=${locator_vars}[接听状态_全部接听状态]

    Select Single Item From Dropdown List    dl_locator=${locator_vars}[是否填写总结_下拉框选中]    item_locator=${locator_vars}[是否填写总结_已总结]
    Select Single Item From Dropdown List    dl_locator=${locator_vars}[是否填写总结_下拉框选中]    item_locator=${locator_vars}[是否填写总结_未总结]
    Select Single Item From Dropdown List    dl_locator=${locator_vars}[是否填写总结_下拉框选中]    item_locator=${locator_vars}[是否填写总结_全部总结填写情况]

    Select Single Item From Dropdown List    dl_locator=${locator_vars}[处理状态_下拉框选中]    item_locator=${locator_vars}[处理状态_未处理]
    Select Single Item From Dropdown List    dl_locator=${locator_vars}[处理状态_下拉框选中]    item_locator=${locator_vars}[处理状态_未解决]
    Select Single Item From Dropdown List    dl_locator=${locator_vars}[处理状态_下拉框选中]    item_locator=${locator_vars}[处理状态_全部处理状态]
    Select Single Item From Dropdown List    dl_locator=${locator_vars}[处理状态_下拉框选中]    item_locator=${locator_vars}[处理状态_已解决]

    Log    ---------- Tc1 step 5: 下拉菜单多选 ------------    console=True
    Select Mutiple Items From Dropdown List
    ...    dl_locator=${locator_vars}[最后接待技能组_下拉框选中]
    ...    input_locator=${locator_vars}[最后接待技能组_请输入搜索内容]
    ...    input_content=无技能组
    ...    items_locator=${locator_vars}[最后接待技能组_选项_无技能组]
    ...    commit_locator=${locator_vars}[最后接待技能组_确定]

    Select Mutiple Items From Dropdown List
    ...    dl_locator=${locator_vars}[转接/三方现场_下拉框选中]
    ...    items_locator=${locator_vars}[转接/三方现场_选项_列表]
    ...    commit_locator=${locator_vars}[转接/三方现场_确定]

Tc2 go into ZhiKe - 智客SCRM
    [Documentation]
    ...    -  xxxxxx
    ...    -  xxxxxx
    ...    -  xxxxxx

    [Tags]    Sanity    2

    Log    ---------- Tc2 step 0: 进入智客SCRM > 通话记录 ------------
    Click Link    ${locator_vars}[智客SCRM]
    Wait Until Page Contains    客户中心    60s
    Click Element    xpath=//a[text()="待分配客户"]
    Wait Until Page Contains    待分配客户    60s

    Log    ---------- Tc2 step 1: 齿轮下拉列表 ------------
    Click Element    xpath=//*[@id="root"]/div/div[3]/div[2]/div/div/div[2]/div/div/div/div[2]/div/div/div[4]      #点击齿轮
	Sleep    0.5
	Click Element    xpath=//*[@id="root"]/div/div[3]/div[2]/div/div/div[2]/div/div/div/div[2]/div/div/div[4]/div/div/div/div/div[2]/div[1]/div/label/span[2]    #选中列展示
	Sleep    0.5
	Click Element    xpath=//*[@id="root"]/div/div[3]/div[2]/div/div/div[2]/div/div/div/div[2]/div/div/div[4]/div/div/div/div/div[2]/div[1]/div/span     #点击重置
	Sleep    0.5
    Click Element    xpath=//*[@id="root"]/div/div[3]/div[2]/div/div/div[2]/div/div/div/div[2]/div/div/div[4]/div/div/div/div/div[2]/div[2]/div/div[7]/label/span[2]    #点击QQ
	Sleep    0.5
    Click Element    xpath=//*[@id="root"]/div/div[3]/div[2]/div/div/div[2]/div/div/div/div[2]/div/div/div[4]/div/div/div/div/div[2]/div[2]/div/div[10]/label/span[2]	#点击界面看不到的元素

    Log    ---------- Tc2 step 2: 上传文件 ------------
    Upload Local File
    ...    batch_import_button_locator=${locator_vars}[上传文件_批量导入]
    ...    upload_button_locator=${locator_vars}[上传文件_上传文件]
    ...    file=${locator_vars}[上传文件_文件]
    ...    import_button_locator=${locator_vars}[上传文件_导入]
    ...    confirm_button_locator=${locator_vars}[上传文件_确认]
    ...    sleep_time=2
