*** Settings ***
Documentation
...    Keyword List:
...        Logon Soboten
...        Logon Test Environment
...        Logon Cloud Customer Service
...        Logon Cloud Outgoing Call
...        Login initialization
...        Get Current Windows Handles
...        Open Browser And Set Size
...        Fetch Json Vars
...        Write Vars Into File
...        Get Vars From File
...        Write Url And Session Into File
...        Debug Mode
...        Select Single Item From Dropdown List
...        Select Single Item From Dropdown Random List
...        Select All Or Cancel All In Dropdown List By Title
...        Select All Or Cancel All In Dropdown List By Attribute
...        Select Mutiple Items From Dropdown List
...        Select Mutiple Items From Dropdown Random List
...        Check Whether Items are selected In Dropdown List
...        Get Dropdown List Content
...        Check Items Exist Or Not In String
...        Check Items Exist Or Not In List
...        Execute Click Operation For List Exist Items
...        Select Checkbox Items
...        Select Checkbox Items By Element Attribute
...        Upload Local File
...        Clear Text Information
...        Input Text And Search
...        Input Text And Check Result
...        Check Flash Prompt Message
...        Get Table Current Page Line Number
...        Get Table Total Line Number
...        Get Table Data For Line Or Current Page
...        Get Table Data For All
...        Get Table Data For Column
...        Get Table Column Number
...        Check Table Data For Null
...        Check Whether Search Getting Table Data Match Column Value
...        Execute Action By Element Attribute
...        Operate Scroll Bar
...        Fetch Word Counter
...        Fetch Audio Duration
...        Compare Number Values
...        Set Calendar From Start To End By Input Date And Time
#-------------------------------------------
...        Check Call Details
...        Check Voice Content
...        Create Outgoing Call Task
...        Fetch TemplateId
...        Fetch TemplateId By Curl
...        Fetch CompanyId By Curl
...        Fetch Token By Curl

#*********************************************************************
*** Variables ***
${timeout}    60

#*********************************************************************

*** Keywords ***

Logon Soboten
    [Documentation]    根据参数logon_type值，登录相应的智齿系统
    [Arguments]    ${email}=${gbl_vars}[email]
    ...            ${password}=${gbl_vars}[password]	
    ...            ${logon_type}=0         #  0 is test_environment    1 is "云客服"    2 is "云外呼"    3 is "智客"
	
    Run Keyword If    '@' not in "${email}" or '.' not in "${email}"    Fail    email format is wrong, please double check!
    ${password_length}    Get Length    ${password}
    Run Keyword If    ${password_length} < 8    Fail    Password is less than 8 digits
	
    Run Keyword If    ${logon_type}>0    Click Element    xpath=//div[text()="登录"]
	
    Run Keyword If    ${logon_type}==0    Logon Test Environment          email=${email}    password=${password}
    ...    ELSE IF    ${logon_type}==1    Logon Cloud Customer Service    email=${email}    password=${password}
    ...    ELSE IF	  ${logon_type}==2    Logon Cloud Outgoing Call       email=${email}    password=${password}
	
Logon Test Environment
    [Documentation]    登录智齿测试系统
    [Arguments]    ${email}={gbl_vars}[email]
    ...            ${password}=${gbl_vars}[password]
		
    Wait Until Page Contains    登录智齿客服，开启智慧客服新篇章    60s
	
    Input Text    id=userEmail       ${email}
    Input Text    id=userPassword    ${password}

    Click Button    xpath=//button[text()="登 录"]
	
#Logon Test Environment
#    [Documentation]    登录智齿测试系统
#    [Arguments]    ${email}=${gbl_vars}[email]
#    ...            ${password}=${gbl_vars}[password]
#	
#    Log    ${email}
#    Log    ${password}
#		
#    Wait Until Page Contains    登录智齿外呼，开启智能外呼新篇章    60s	
#	
#    Input Text    css=[type=text][name=username]       ${email}
#    Input Text    css=[type=password][name=password]    ${password}
#
#    Click Button    xpath=//button[text()="登录"]
		
Logon Cloud Customer Service
    [Documentation]    登录智齿—云客服
    [Arguments]    ${email}=${gbl_vars}[email]
    ...            ${password}=${gbl_vars}[password]
	
    Click Element    xpath=//a[text()="登录云客服"]
    Get Current Windows Handles
	
    Wait Until Page Contains    登录智齿客服，开启智慧客服新篇章    60s
	
    Input Text    id=userEmail       ${email}
    Input Text    id=userPassword    ${password}

    Click Button    xpath=//button[text()="登录"]
				
Logon Cloud Outgoing Call 
    [Documentation]    登录智齿—云外呼
    [Arguments]    ${email}=${gbl_vars}[email]
    ...            ${password}=${gbl_vars}[password]
	
    Click Element    xpath=//a[text()="登录云外呼"]
    Get Current Windows Handles
		
    Wait Until Page Contains    登录智齿外呼，开启智能外呼新篇章    60s

    Input Text    css=[type=text][name=username]       ${email}
    Input Text    css=[type=password][name=password]    ${password}
    Click Button    xpath=//button[text()="登录"]
	
Get Current Windows Handles
    [Documentation]    当一个web页面上有多个窗口时，得到当前窗口的handle
	
    @{child_handle}    Get Window Handles
    log    ${child_handle}
    log    @{child_handle}[-1]
    Switch Window    @{child_handle}[-1]
	
Open Browser And Set Size
    [Documentation]    打开指定类型的浏览器，并设置窗口大小
    [Arguments]    ${url}=http://test.sobot.com/console/login
    ...            ${browser}=gc
    ...            ${set_window_size}=${True}
    ...            ${hor_pixels}=1920
    ...            ${ver_pixels}=1080
    ...            ${set_max_browser_window}=${True}
    
    Open Browser    ${url}    ${browser}
    Run Keyword If    ${set_window_size}           Set Window Size    ${hor_pixels}    ${ver_pixels}
    Run Keyword If    ${set_max_browser_window}    Maximize Browser Window
	
Login initialization
    [Documentation]    仅为智能外呼登录初始化
    [Arguments]    ${url}=${gbl_vars}[url]
    ...            ${browser}=gc
    ...            ${set_window_size}=${True}
    ...            ${hor_pixels}=1920
    ...            ${ver_pixels}=1080
    ...            ${set_max_browser_window}=${True}
    ...            ${logon_type}=0
    ...            ${email}=${gbl_vars}[email]
    ...            ${password}=${gbl_vars}[password]
    ...            ${implicit_wait_value}=5
	
    Close All Browsers
    Open Browser And Set Size    url=${url}    browser=${browser}    set_window_size=${True}    set_max_browser_window=${True}
    Logon Soboten    logon_type=${logon_type}    email=${email}    password=${password}
    Set Selenium Implicit Wait    value=${implicit_wait_value}

Compare Number Values
    [Documentation]    两个数值比较
    [Arguments]    ${value1}=value1
    ...            ${operator}==
    ...            ${value2}=value2
    ...            ${offset_value}=0
	
    #usage example:
    #Compare Number Values    value1=${getting_call_duration}    operator=<    value2=${call_duration}  
	
    Log    value1 is: ${value1}
    Log    operator is: ${operator}
    Log    value2 is: ${value2}
    Log    offset_value is: ${offset_value}
    Log    =======================================================================
	
    ${value2}    Evaluate    ${offset_value} + ${value2}
	
    Run Keyword If    ${value1} ${operator} ${value2}    Fail    value1 and value2 compare failed    

Fetch Audio Duration
    [Documentation]    得到audio播放总时长
    [Arguments]    ${locator}        #Mandatory parameters,请提供java scripts路径
    [Return]       ${result}         #返回的audio的播放总时长

    #usage example:
    #${duration}    Fetch Audio Duration    locator=audio

    Log    locator is: ${locator}
    Log    =======================================================================

    ${result}    Execute Javascript    return document.querySelector("${locator}").duration
    ${result}    Convert To Integer    ${result}
    Log    ${result}
	
Select All Or Cancel All In Dropdown List By Attribute
    [Documentation]    通过属性全选或者全取消下拉列表里的所有项
    [Arguments]    ${dl_locator}                   #Mandatory parameters,下拉框选中位置
    ...            ${all_locator}                  #Mandatory parameters,"全部"或"全选"或其他表示全选位置的locator
    ...            ${all_attribute_value}          #Mandatory parameters,请根据需要,给全选或全取消的属性状态值
    ...            ${all_attribute_name}=class     #通过哪个属性获得的属性值,请给这个属性名
    ...            ${commit_locator}=${None}       #"确定"或"提交"按钮的locator
    ...            ${sleep_time}=0.5

    #usage example:
    #Select All Or Cancel All In Dropdown List    dl_locator=${locator_vars}[任务_创建人账号_选中]
    #...    all_locator=${locator_vars}[任务_创建人账号_全部]
    #...    all_attribute_value=autotest_active
    #...    commit_locator=${locator_vars}[任务_创建人账号_确定]

    Log    dl_locator is: ${dl_locator}
    Log    all_locator is: ${all_locator}
    Log    all_attribute_value is: ${all_attribute_value}
    Log    all_attribute_name is: ${all_attribute_name}
    Log    commit_locator is: ${commit_locator}
    Log    =======================================================================
	
	Click Element    ${dl_locator}
    Sleep    ${sleep_time}
    Execute Action By Element Attribute    locator=${all_locator}    attribute_name=${all_attribute_name}    attribute_value=${all_attribute_value}
    Sleep    ${sleep_time}
	
    Run Keyword If    '${commit_locator}' is not '${None}'    Click Element    ${commit_locator}      #提交
    ...       ELSE    Click Element    ${dl_locator}              #点击下拉框选中, 为了让下拉框关闭
	
Select Single Item From Dropdown Random List 
    [Documentation]    从内容可变的下拉列表中选择一项内容
    [Arguments]    ${dl_locator}            #Mandatory parameters,下拉框选中位置
    ...            ${dl_content_locator}    #Mandatory parameters,请给下拉框下半部分文本部分的整体locator
    ...            ${single_item}           #Mandatory parameters,单选项内容
    ...            ${append_locator}        #Mandatory parameters,单选项位置
    ...            ${sleep_time}=0.2

    #usage example:
    #Select Single Item From Dropdown Random List    dl_locator=${dl_locator}    dl_content_locator=${dl_content_locator}    single_item=${single_item}    append_locator=${append_locator}

    Log    dl_locator is: ${dl_locator}
    Log    dl_content_locator is: ${dl_content_locator}
    Log    single_item is: ${single_item}
    Log    append_locator is: ${append_locator}
    Log    =======================================================================

    ${result}    Get Dropdown List Content    dl_locator=${dl_locator}    dl_content_locator=${dl_content_locator}
    Check Items Exist Or Not In String    all_data=${result}    check_items=${single_item}
    Execute Click Operation For List Exist Items    basic_locator=${dl_content_locator}    append_locator=${append_locator}

Select Mutiple Items From Dropdown Random List
    [Documentation]    从内容可变的下拉列表中选择一项或多项内容
    [Arguments]    ${dl_locator}                          #Mandatory parameters,下拉框选中位置
    ...            ${dl_content_locator}                  #Mandatory parameters,请给下拉框下半部分文本部分的整体locator
    ...            ${mutiple_items}                       #Mandatory parameters,多选项内容,多个时需传入一个list
    ...            ${mutiple_items_append_locator}        #Mandatory parameters,多选项内容对应的追加locator,多个时需传入一个list
    ...            ${commit_locator}=${None}              #提交按钮位置
    ...            ${sleep_time}=0.2

    #usage example:
    #Select Mutiple Items From Dropdown Random List    dl_locator=${dl_locator}    dl_content_locator=${dl_content_locator}    mutiple_items=${mutiple_items}    mutiple_items_append_locator=${mutiple_items_append_locator}

    Log    dl_locator is: ${dl_locator}
    Log    dl_content_locator is: ${dl_content_locator}
    Log    mutiple_items is: ${mutiple_items}
    Log    mutiple_items_append_locator is: ${mutiple_items_append_locator}
    Log    commit_locator is: ${commit_locator}
    Log    =======================================================================
	
    @{mutiple_items} =   Run Keyword If    isinstance($mutiple_items,list)     Copy List      ${mutiple_items}
    ...          ELSE                                        Create List    ${mutiple_items}

    @{mutiple_items_append_locator} =   Run Keyword If    isinstance($mutiple_items_append_locator,list)     Copy List      ${mutiple_items_append_locator}
    ...          ELSE                                        Create List    ${mutiple_items_append_locator}	

    ${result}    Get Dropdown List Content    dl_locator=${dl_locator}    dl_content_locator=${dl_content_locator}
    Check Items Exist Or Not In String    all_data=${result}    check_items=${mutiple_items}
    
    Sleep    ${sleep_time}
	Run Keyword If    '${commit_locator}' is not '${None}'    Execute Click Operation For List Exist Items    basic_locator=${dl_content_locator}    append_locator=${mutiple_items_append_locator}    commit_locator=${commit_locator}
    ...    ELSE IF    '${dl_locator}' is not '${None}'    Execute Click Operation For List Exist Items    basic_locator=${dl_content_locator}    append_locator=${mutiple_items_append_locator}    dl_locator=${dl_locator}

Create Outgoing Call Task
    [Documentation]    创建智能外呼任务
    [Arguments]    ${create_task_locator}                        #Mandatory parameters,"新建任务"按钮的locator
    ...            ${task_name_inputbox_locator}                 #Mandatory parameters,任务名称输入框locator
    ...            ${task_name_input_info}                       #Mandatory parameters,任务名称输入信息
    ...            ${dl_locator}                                 #Mandatory parameters,下拉框选中位置locator
    ...            ${dl_content_locator}                         #Mandatory parameters,请给下拉框下半部分文本部分的整体locator
    ...            ${single_item}                                #Mandatory parameters,单选项内容
    ...            ${append_locator}                             #Mandatory parameters,单选项位置
    ...            ${robot_number_inputbox_locator}              #Mandatory parameters,机器人输入框locator
    ...            ${commit_button_locator}                      #Mandatory parameters,确定按钮locator
    ...            ${robot_number}=1                             #机器人数量
    ...            ${explicit_number_dl_locator}=${None}                 #外显号码locator
    ...            ${explicit_number_title_locator}=${None}              #外显号码标题locator
    ...            ${explicit_number_title_content}=${None}              #外显号码标题期望内容
    ...            ${explicit_number_all_locator}=${None}                #外显号码"全部号码"locator
    ...            ${explicit_number_content_locator}=${None}            #外显号码下拉内容部分locator
    ...            ${explicit_number_choice_items}=${None}               #外显号码选择项,用于check选择项在下拉列表里是否存在
    ...            ${explicit_number_choice_append_locator}=${None}      #外显号码选择项对应的追加locator
    ...            ${explicit_rule}=${None}                      #外显规则locator
    ...            ${explicit_basic_rule}=${None}                #外显基础规则locator
    ...            ${priority_locator}=${None}                   #想选的优先级locator
    ...            ${number_hiding_strategy_locator}=${None}     #想选的号码隐藏策略locator
    ...            ${dial_result_push_locator}=${None}           #拨打结果推送开启/关闭locator	
    ...            ${dial_result_push_time_locator}=${None}      #拨打结果推送时机locator	
    ...            ${dial_result_push_addr_locator}=${None}      #拨打结果推送地址locator
    ...            ${dial_result_push_addr_info}=${None}         #拨打结果推送地址内容
    ...            ${auto_redial_setting_locator}=${None}        #自动重拨设置开启/关闭locator	
    ...            ${redial_interval_locator}=${None}            #重拨间隔框选中locator
    ...            ${redial_interval_value_locator}=${None}      #想选的重拨间隔值locator
    ...            ${redial_times_locator}=${None}               #重拨次数框选中locator
    ...            ${redial_times_value_locator}=${None}         #想选的重拨次数值locator
    ...            ${redial_condition_item_locator_and_attribute_dict}=${None}      #想选的重拨条件项locator及对应的状态字典
    ...            ${redial_condition_item_attribute_value}=class                   #想选的重拨条件项状态属性值
    ...            ${filter_strategy_locator}=${None}            #过滤策略开启/关闭locator		
    ...            ${outcall_upper_limit_locator}=${None}        #外呼上限框选中locator
    ...            ${outcall_upper_limit_value_locator}=${None}  #外呼上限值locator	
    ...            ${day_limit_locator}=${None}                  #天内限制框选中locator
    ...            ${day_limit_value_locator}=${None}            #天内限制值locator
    ...            ${redial_condition_locator_list}=${None}      #想选的重拨条件,可以是一个,也可以是一个list
    ...            ${flash_prompt_locator}=${None}               #快闪提示位置
    ...            ${flash_prompt_expected_info}=${None}         #快闪期望信息
    ...            ${sleep_time}=0.2
	
    #usage example:
    #Create Outgoing Call Task	
    #...    create_task_locator=${locator_vars}[任务_新建任务]
    #...    task_name_inputbox_locator=${locator_vars}[任务_新建任务_任务名称输入框]
    #...    task_name_input_info=${locator_vars}[任务_新建任务_任务名称输入信息]
    #...    dl_locator=${locator_vars}[任务_新建任务_选择话术框选中]
    #...    dl_content_locator=${locator_vars}[任务_新建任务_选择话术下拉内容框]
    #...    single_item=接口
    #...    append_locator=//span[text()="接口"]
    #...    explicit_rule=${locator_vars}[任务_新建任务_外显规则]
    #...    explicit_basic_rule=${locator_vars}[任务_新建任务_外显规则_轮流外显]
    #...    robot_number_inputbox_locator=${locator_vars}[任务_新建任务_机器人数量输入框]
    #...    robot_number=3
    #...    priority_locator=${locator_vars}[任务_新建任务_优先级_高]
    #...    number_hiding_strategy_locator=${locator_vars}[任务_新建任务_号码隐藏策略_隐藏中间四位]
    #...    dial_result_push_locator=${locator_vars}[任务_新建任务_拨打结果推送]
    #...    dial_result_push_time_locator=${locator_vars}[任务_新建任务_拨打结果推送_转人工后推送]
    #...    dial_result_push_addr_locator=${locator_vars}[任务_新建任务_拨打结果推送_推送地址输入框]
    #...    dial_result_push_addr_info=${locator_vars}[任务_新建任务_拨打结果推送_推送地址输入内容]
    #...    auto_redial_setting_locator=${locator_vars}[任务_新建任务_自动重拨设置]
    #...    redial_interval_locator=${locator_vars}[任务_新建任务_自动重拨设置_重拨间隔框选中]
    #...    redial_interval_value_locator=${locator_vars}[任务_新建任务_自动重拨设置_重拨间隔值]
    #...    redial_times_locator=${locator_vars}[任务_新建任务_自动重拨设置_重拨次数框选中]
    #...    redial_times_value_locator=${locator_vars}[任务_新建任务_自动重拨设置_重拨次数值]
    #...    redial_condition_item_locator_and_attribute_dict=${locator_vars}[任务_新建任务_自动重拨设置_重拨条件]
    #...    filter_strategy_locator=${locator_vars}[任务_新建任务_过滤策略]
    #...    outcall_upper_limit_locator=${locator_vars}[任务_新建任务_过滤策略_外呼上线框选中]
    #...    outcall_upper_limit_value_locator=${locator_vars}[任务_新建任务_过滤策略_外呼上线值]
    #...    day_limit_locator=${locator_vars}[任务_新建任务_过滤策略_天内限制框选中]
    #...    day_limit_value_locator=${locator_vars}[任务_新建任务_过滤策略_天内限制值]
    #...    commit_button_locator=${locator_vars}[任务_新建任务_确定]
    #...    flash_prompt_locator=${locator_vars}[任务_新建任务_快闪提示]
    #...    flash_prompt_expected_info=添加成功
    #=======================================================================
	
    Log    create_task_locator is: ${create_task_locator}
    Log    task_name_inputbox_locator is: ${task_name_inputbox_locator}
    Log    task_name_input_info is: ${task_name_input_info}
    Log    dl_locator is: ${dl_locator}
    Log    dl_content_locator is: ${dl_content_locator}
    Log    single_item is: ${single_item}
    Log    append_locator is: ${append_locator}
    Log    explicit_number_dl_locator is: ${explicit_number_dl_locator}
    Log    explicit_number_title_locator is: ${explicit_number_title_locator}
    Log    explicit_number_title_content is: ${explicit_number_title_content}
    Log    explicit_number_all_locator is: ${explicit_number_all_locator}
    Log    explicit_number_content_locator is: ${explicit_number_content_locator}
    Log    explicit_number_choice_items is: ${explicit_number_choice_items}
    Log    explicit_number_choice_append_locator is: ${explicit_number_choice_append_locator}
    Log    explicit_rule is: ${explicit_rule}
    Log    explicit_basic_rule is: ${explicit_basic_rule}
    Log    robot_number_inputbox_locator is: ${robot_number_inputbox_locator}
    Log    robot_number is: ${robot_number}
    Log    priority_locator is: ${priority_locator}
    Log    number_hiding_strategy_locator is: ${number_hiding_strategy_locator}
    Log    dial_result_push_locator is: ${dial_result_push_locator}
    Log    dial_result_push_time_locator is: ${dial_result_push_time_locator}
    Log    dial_result_push_addr_locator is: ${dial_result_push_addr_locator}
    Log    dial_result_push_addr_info is: ${dial_result_push_addr_info}
    Log    commit_button_locator is: ${commit_button_locator}
    Log    auto_redial_setting_locator is: ${auto_redial_setting_locator}
    Log    redial_interval_locator is: ${redial_interval_locator}
    Log    redial_interval_value_locator is: ${redial_interval_value_locator}
    Log    redial_times_locator is: ${redial_times_locator}
    Log    redial_times_value_locator is: ${redial_times_value_locator}
    Log    redial_condition_item_locator_and_attribute_dict is: ${redial_condition_item_locator_and_attribute_dict}	
    Log    filter_strategy_locator is: ${filter_strategy_locator}		
    Log    outcall_upper_limit_locator is: ${outcall_upper_limit_locator}
    Log    outcall_upper_limit_value_locator is: ${outcall_upper_limit_value_locator}	
    Log    day_limit_locator is: ${day_limit_locator}
    Log    day_limit_value_locator is: ${day_limit_value_locator}
    Log    flash_prompt_locator is: ${flash_prompt_locator}
    Log    flash_prompt_expected_info is: ${flash_prompt_expected_info}
    Log    =======================================================================
	
    Log    点击新建任务
    Click Element    ${create_task_locator}
    Wait Until Page Contains    创建任务    ${timeout}

    Log    输入任务名称
    Input Text    ${task_name_inputbox_locator}    ${task_name_input_info}
	
    Log    选择话术
    Select Single Item From Dropdown Random List    dl_locator=${dl_locator}    dl_content_locator=${dl_content_locator}    single_item=${single_item}    append_locator=${append_locator}
	
    Log    外显号码
    Run Keyword If    '${explicit_number_dl_locator}' is not '${None}' and '${explicit_number_all_locator}' is '${None}'    Fail    explicit_number_all_locator is None, this isn't expected result
    Run Keyword If    '${explicit_number_dl_locator}' is not '${None}' and '${explicit_number_title_locator}' is '${None}'    Fail    explicit_number_title_locator is None, this isn't expected result
    Run Keyword If    '${explicit_number_dl_locator}' is not '${None}' and '${explicit_number_title_content}' is '${None}'    Fail    explicit_number_title_content is None, this isn't expected result
    Run Keyword If    '${explicit_number_dl_locator}' is not '${None}' and '${explicit_number_content_locator}' is '${None}'    Fail    explicit_number_content_locator is None, this isn't expected result
    Run Keyword If    '${explicit_number_dl_locator}' is not '${None}' and '${explicit_number_choice_items}' is '${None}'    Fail    explicit_number_choice_items is None, this isn't expected result
    Run Keyword If    '${explicit_number_dl_locator}' is not '${None}' and '${explicit_number_choice_append_locator}' is '${None}'    Fail    explicit_number_choice_append_locator is None, this isn't expected result

    Run Keyword If    '${explicit_number_dl_locator}' is not '${None}'
    ...    Select All Or Cancel All In Dropdown List By Title
    ...    dl_locator=${explicit_number_dl_locator}
    ...    dl_title_locator=${explicit_number_title_locator}
    ...    title_content=${explicit_number_title_content}
    ...    all_locator=${explicit_number_all_locator}
    
    Run Keyword If    '${explicit_number_dl_locator}' is not '${None}'
    ...    Select Mutiple Items From Dropdown Random List
    ...    dl_locator=${explicit_number_dl_locator}
    ...    dl_content_locator=${explicit_number_content_locator}
    ...    mutiple_items=${explicit_number_choice_items}
    ...    mutiple_items_append_locator=${explicit_number_choice_append_locator}


    Log    外显规则
    Run Keyword If    '${explicit_rule}' is not '${None}'    Click Element    ${explicit_rule}
    Run Keyword If    '${explicit_basic_rule}' is not '${None}'    Click Element    ${explicit_basic_rule}
	
    Log    机器人数量
    Input Text    ${robot_number_inputbox_locator}    ${robot_number}
	
    Log    优先级
    Run Keyword If    '${priority_locator}' is not '${None}'    Click Element    ${priority_locator}
	
    Log    拨打时间段
	
    Log    号码隐藏策略
    Run Keyword If    '${number_hiding_strategy_locator}' is not '${None}'    Click Element    ${number_hiding_strategy_locator}
	
    Log    任务有效期 	
	
    Log    拨打结果推送
    Run Keyword If    '${dial_result_push_locator}' is not '${None}'    Click Element    ${dial_result_push_locator}
    Run Keyword If    '${dial_result_push_locator}' is not '${None}' and '${dial_result_push_time_locator}' is not '${None}'    Click Element    ${dial_result_push_time_locator}

    Run Keyword If    '${dial_result_push_time_locator}' is not '${None}' and '${dial_result_push_addr_locator}' is '${None}'    Fail    "dial_result_push_addr_locator" is None, please give the corresponding value
    Run Keyword If    '${dial_result_push_time_locator}' is not '${None}' and '${dial_result_push_addr_info}' is '${None}'    Fail    "dial_result_push_addr_info" is None, please give the corresponding value

    Run Keyword If    '${dial_result_push_locator}' is not '${None}' and '${dial_result_push_addr_locator}' is not '${None}' and '${dial_result_push_addr_info}' is not '${None}'    Input Text    ${dial_result_push_addr_locator}    ${dial_result_push_addr_info}

    Log    过滤策略
    Sleep    ${sleep_time}
    Run Keyword If    '${filter_strategy_locator}' is not '${None}'    Click Element    ${filter_strategy_locator}

    Run Keyword If    '${filter_strategy_locator}' is '${None}' and '${outcall_upper_limit_locator}' is not '${None}'    Fail    filter_strategy_locator is None, so can't show outcall_upper_limit_locator
    Run Keyword If    '${filter_strategy_locator}' is '${None}' and '${outcall_upper_limit_value_locator}' is not '${None}'    Fail    filter_strategy_locator is None, so can't show outcall_upper_limit_value_locator
    Run Keyword If    '${filter_strategy_locator}' is '${None}' and '${day_limit_locator}' is not '${None}'    Fail    filter_strategy_locator is None, so can't show day_limit_locator
    Run Keyword If    '${filter_strategy_locator}' is '${None}' and '${day_limit_value_locator}' is not '${None}'    Fail    filter_strategy_locator is None, so can't show day_limit_value_locator
		
    Run Keyword If    '${outcall_upper_limit_locator}' is not '${None}' and '${outcall_upper_limit_value_locator}' is not '${None}'    Select Single Item From Dropdown List    dl_locator=${outcall_upper_limit_locator}    item_locator=${outcall_upper_limit_value_locator}
    Run Keyword If    '${day_limit_locator}' is not '${None}' and '${day_limit_value_locator}' is not '${None}'    Select Single Item From Dropdown List    dl_locator=${day_limit_locator}    item_locator=${day_limit_value_locator}
 		
    Log    自动重拨设置
    Run Keyword If    '${auto_redial_setting_locator}' is not '${None}'    Click Element    ${auto_redial_setting_locator}
    
    Run Keyword If    '${auto_redial_setting_locator}' is '${None}' and '${redial_interval_locator}' is not '${None}'    Fail    auto_redial_setting_locator is None, so can't show redial_interval_locator
    Run Keyword If    '${auto_redial_setting_locator}' is '${None}' and '${redial_interval_value_locator}' is not '${None}'    Fail    auto_redial_setting_locator is None, so can't show redial_interval_value_locator
    Run Keyword If    '${auto_redial_setting_locator}' is '${None}' and '${redial_times_locator}' is not '${None}'    Fail    auto_redial_setting_locator is None, so can't show redial_times_locator
    Run Keyword If    '${auto_redial_setting_locator}' is '${None}' and '${redial_times_value_locator}' is not '${None}'    Fail    auto_redial_setting_locator is None, so can't show redial_times_value_locator
	
    Run Keyword If    '${redial_interval_locator}' is not '${None}' and '${redial_interval_value_locator}' is not '${None}'    Select Single Item From Dropdown List    dl_locator=${redial_interval_locator}    item_locator=${redial_interval_value_locator}
    Run Keyword If    '${redial_times_locator}' is not '${None}' and '${redial_times_value_locator}' is not '${None}'    Select Single Item From Dropdown List    dl_locator=${redial_times_locator}    item_locator=${redial_times_value_locator}
 
    Run Keyword If    ${redial_condition_item_locator_and_attribute_dict} is not ${None}    Select Checkbox Items By Element Attribute    items_dict=${redial_condition_item_locator_and_attribute_dict}    attribute_name=${redial_condition_item_attribute_value}

    Log    确定和判断
    Click Element    ${commit_button_locator}
    Run Keyword If    '${flash_prompt_locator}' is not '${None}' and '${flash_prompt_expected_info}' is not '${None}'    Check Flash Prompt Message    flash_prompt_locator=${flash_prompt_locator}    excepted_message=${flash_prompt_expected_info}

Select Checkbox Items
    [Documentation]    选择多选框不根据元素状态
    [Arguments]    ${items_locator}         #Mandatory parameters,请传入一个或多个项的locator
    ...            ${sleep_time}=0.2
	
    #usage example:
    #Select Checkbox Items    items_locator=${redial_condition_items_locator}

    Log    items_locator is： ${items_locator}
    Log    =======================================================================	
    	
    @{items_locator} =   Run Keyword If    isinstance($items_locator,list)     Copy List      ${items_locator}
    ...          ELSE                                        Create List    ${items_locator}
    
    FOR    ${item_locator}    IN    @{items_locator}
        Log    ${item_locator}
        Click Element    ${item_locator}
    END

Select Checkbox Items By Element Attribute
    [Documentation]    选择多选框根据元素状态
    [Arguments]    ${items_dict}            #Mandatory parameters,请传入一个字典,key是元素的locator,value是元素的属性值
    ...            ${attribute_name}        #Mandatory parameters,通过哪个属性名称得到属性值,请给这个属性名称
    ...            ${sleep_time}=0.2
	
    #usage example:
    #Select Checkbox Items By Element Attribute    items_dict=${redial_condition_item_locator_and_attribute_dict}    attribute_name=${redial_condition_item_attribute_value}

    Log    items_dict is： ${items_dict}
    Log    =======================================================================	
    	
    @{keys_list}    Get Dictionary Keys    ${items_dict}
    Log   ${keys_list}

    FOR    ${item}    IN    @{keys_list}
        Log    ${item}
        Log    ${items_dict}[${item}]
        Execute Action By Element Attribute    locator=${item}    attribute_name=${attribute_name}    attribute_value=${items_dict}[${item}]
    END
	
Check Voice Content
    [Documentation]    check智能外呼通话语音信息
    [Arguments]    ${robot_voice}           #Mandatory parameters,机器人语音,可以是一条语音,可以也是一个list
    ...            ${customer_voice}        #Mandatory parameters,客户语音,可以是一条语音,可以也是一个list
    ...            ${sleep_time}=0.2
	
    #usage example:	
    #${r_var1}    Set Variable    喂，你好。
    #${r_var2}    Set Variable    好家长，我这边是高途课堂的小智老师啊，然后小朋友呢有在我们这边有上过课的，您还记得吧？
    #${r_var3}    Set Variable    呃，是这样的，就我们高途课堂呢针对老用户推出了金牌名师的春季超前预习课。没有老师呢来一对一的帮助孩子来快速掌握学科重难点。这个课程呢现在只需要十八块钱就可以了。。另外还会赠送价值四十八元的多功能保温杯啊，现在报名的话可以优先安排上课。我这边给您发个优惠链接，您记得及时领取哈。
    #@{r_list}    Create List    ${r_var1}    ${r_var2}    ${r_var3}
    ##@{r_list}    Create List     喂，你好。    好家长，我这边是高途课堂的小智老师啊，然后小朋友呢有在我们这边有上过课的，您还记得吧？    呃，是这样的，就我们高途课堂呢针对老用户推出了金牌名师的春季超前预习课。没有老师呢来一对一的帮助孩子来快速掌握学科重难点。这个课程呢现在只需要十八块钱就可以了。。另外还会赠送价值四十八元的多功能保温杯啊，现在报名的话可以优先安排上课。我这边给您发个优惠链接，您记得及时领取哈。
    #@{c_list}    Create List     行    行
    #Check Voice Content    robot_voice=${r_list}    customer_voice=${c_list}
	
    Log    robot_voice is： ${robot_voice}
    Log    customer_voice is： ${customer_voice}
    Log    =======================================================================
    
    @{robot_voice} =   Run Keyword If    isinstance($robot_voice,list)     Copy List      ${robot_voice}
    ...          ELSE                                        Create List    ${robot_voice}
    
    @{customer_voice} =   Run Keyword If    isinstance($customer_voice,list)     Copy List      ${customer_voice}
    ...          ELSE                                        Create List    ${customer_voice}
    
    #处理数据,得到想要的数据
    ${data}    Get Text    //body
    Log    ${data}
    @{temp_list_1}    Split String From Right    ${data}    话术路径 关闭    1
    Log    ${temp_list_1}
    @{temp_list_2}    Split String    ${temp_list_1}[1]    删除 取消选择
    Log    ${temp_list_2}[0]
    @{response}    Split To Lines    ${temp_list_2}[0]
    Log   ${response}
    Remove From List	${response}    0
    Log   ${response}
    
    ${loop_num}    Get Length    ${response}
    ${quotient}    Evaluate    ${loop_num}%2
    Run Keyword If    ${quotient}!=0    Fail    quotient isn't 0, please check why
	
    #处理"机器人"和"客户"名称为不同
    ${times}    Set Variable    1
    FOR    ${i}    IN RANGE    0    ${loop_num}    2
        Log    ${response}[${i}]
        ${final_robot}    Catenate    SEPARATOR=    机器人    ${times}
        ${final_customer}    Catenate    SEPARATOR=    客户    ${times}
        #Log    ${final_robot}
        #Log    ${final_customer}
        Run Keyword If    '${response}[${i}]' == '机器人'    Set List Value    ${response}    ${i}    ${final_robot}
        Run Keyword If    '${response}[${i}]' == '客户'    Set List Value    ${response}    ${i}    ${final_customer}
        #Log    ${response}
        #Log    ${response}[${i}]
        ${times}    Evaluate    ${times} + 1	
        ${r_times}=    Set Variable If    '${response}[${i}]' == '${final_robot}'    ${times}
        #Log    ${r_times}
    END
    Log    ${response}
	
    #"机器人"和"客户"说的话分别写入字典
    &{my_robot_dict}    Create Dictionary
    &{my_customer_dict}    Create Dictionary
    FOR    ${i}    IN RANGE    0    ${loop_num}    2
        ${j}    Evaluate    ${i} + 1
        Run Keyword If    '机器人' in '${response}[${i}]'     Set To Dictionary    ${my_robot_dict}    ${response}[${i}]=${response}[${j}]
        Run Keyword If    '客户' in '${response}[${i}]'    Set To Dictionary    ${my_customer_dict}    ${response}[${i}]=${response}[${j}]
    END
    Log    ${my_robot_dict}
    Log    ${my_customer_dict}
	
    #取得的数据和传入的数据进行对比
    @{my_robot_dict_value}    Get Dictionary Values    ${my_robot_dict}
    Log    ${my_robot_dict_value} 
	
    @{my_customer_dict_value}    Get Dictionary Values    ${my_customer_dict}
    Log    ${my_customer_dict_value}
	
    FOR    ${getting_item}    IN    @{my_robot_dict_value}
        Log    ${getting_item}
        FOR    ${inputing_item}    IN    @{robot_voice}
            Run Keyword If    '${inputing_item}' in '${getting_item}'    Exit For Loop
            ...       ELSE    Continue For Loop
        END
    END
	
    FOR    ${getting_item}    IN    @{my_customer_dict_value}
        Log    ${getting_item}
        FOR    ${inputing_item}    IN    @{customer_voice}
            Run Keyword If    '${inputing_item}' in '${getting_item}'    Exit For Loop
            ...       ELSE    Continue For Loop
        END
    END
			    
Check Call Details
    [Documentation]    check智能外呼通话详细信息
    [Arguments]    ${phone_number}=${None}           #电话号码
    ...            ${call_result}=${None}            #拨打结果
    ...            ${customer_intention}=${None}     #客户意向
    ...            ${speech_template}=${None}        #话术模板
    ...            ${owned_task}=${None}             #所属任务
    ...            ${customer_response_number}=0     #客户回复数
    ...            ${transfer_to_person}=否          #转人工情况
    ...            ${send_message}=未发送            #短信发送情况
    ...            ${explicit_number}=01021753672    #外显号码
    ...            ${call_duration}=${None}          #通话时长
    ...            ${sleep_time}=0.2
		
    #usage example:
    #Check Call Details
    #...    phone_number=15801490162
    #...    call_result=已接通
    #...    customer_intention=无意向
    #...    speech_template=教育营销_有问题
    #...    owned_task=test008
    #...    customer_response_number=1
    #...    transfer_to_person=否
    #...    send_message=未发送
    #...    explicit_number=01021753672
    #...    call_duration=140	

    Log    phone_number is: ${phone_number}
    Log    call_result is: ${call_result}
    Log    customer_intention is: ${customer_intention}
    Log    speech_template is: ${speech_template}
    Log    owned_task is: ${owned_task}
    Log    customer_response_number is: ${customer_response_number}
    Log    transfer_to_person is: ${transfer_to_person}
    Log    send_message is: ${send_message}
    Log    explicit_number is: ${explicit_number}
    Log    call_duration is: ${call_duration}
    Log    =======================================================================

    #处理数据,得到想要的数据
    ${data}    Get Text    //body
    Log    ${data}

    @{temp_list_1}    Split String From Right    ${data}    变量字段    1
    Log    ${temp_list_1}
    @{temp_list_2}    Split String    ${temp_list_1}[0]    通话基本信息
    Log    ${temp_list_2}[1]
    @{response}    Split To Lines    ${temp_list_2}[1]
    Log   ${response}
    Remove From List	${response}    0
    Log   ${response}
    ${loop_num}    Get Length    ${response}
    ${quotient}    Evaluate    ${loop_num}%2
    Run Keyword If    ${quotient}!=0    Fail    quotient isn't 0, please check why
	
    #把数据写入字典
    &{my_dict}    Create Dictionary
	
    FOR    ${i}    IN RANGE    0    ${loop_num}    2
        ${j}    Evaluate    ${i} + 1
        Set To Dictionary	${my_dict}	${response}[${i}]=${response}[${j}]
    END

    Log    ${my_dict}
		
    #取得的数据和传入的数据进行对比
    Run Keyword If    '${phone_number}' is not '${None}'    Should Be Equal As Strings    ${my_dict}[电话号码]    ${phone_number}											  
    Run Keyword If    '${call_result}' is not '${None}'     Should Be Equal As Strings    ${my_dict}[拨打结果]    ${call_result}											  
    Run Keyword If    '${customer_intention}' is not '${None}'    Should Be Equal As Strings    ${my_dict}[客户意向]    ${customer_intention}																	  
    Run Keyword If    '${speech_template}' is not '${None}'    Should Be Equal As Strings    ${my_dict}[话术模板]    ${speech_template}
    Run Keyword If    '${owned_task}' is not '${None}'    Should Be Equal As Strings   ${my_dict}[所属任务]    ${owned_task}
    Run Keyword If    '${my_dict}[callId]' is '${Empty}'    Fail    callId is empty, this's wrong
	
    ${getting_response_number}    Convert To Integer    ${my_dict}[客户回复数]
    Run Keyword If    '${my_dict}[拨打结果]' != '已接通'    Should Be Equal As Integers    ${getting_response_number}    0
    ...       ELSE    Compare Number Values    value1=${getting_response_number}    operator=<    value2=${customer_response_number}  
	
    Run Keyword If    '${my_dict}[拨打结果]' != '已接通'    Should Be Equal As Strings    ${my_dict}[转人工情况]    否
    ...       ELSE    	Should Be Equal As Strings    ${my_dict}[转人工情况]    ${transfer_to_person}

    Run Keyword If    '${send_message}' is not '${None}'    Should Be Equal As Strings    ${my_dict}[短信发送情况]    ${send_message}											  
    Run Keyword If    '${explicit_number}' is not '${None}'    Should Be Equal As Strings    ${my_dict}[外显号码]    ${explicit_number}											  
    Run Keyword If    '${my_dict}[拨打时间]' is '${Empty}'    Fail    call time is empty, this's wrong

    ${getting_call_duration}    Convert Time    ${my_dict}[通话时长]
    ${getting_call_duration}    Convert To Integer    ${getting_call_duration}
    Log    ${getting_call_duration}
    Run Keyword If    '${call_duration}' is not '${None}'    Compare Number Values    value1=${getting_call_duration}    operator=<    value2=${call_duration}  

Operate Scroll Bar
    [Documentation]    操作横向纵向滚动条
    [Arguments]    ${locator}          #Mandatory parameters,请提供java scripts路径
    ...            ${type}=HV          # H(表示横向滚动条)，V(纵向滚动条)，HV(横向滚动条和纵向滚动条)
    ...            ${h_value}=9999     #横向滚动条距离左边的值
    ...            ${v_value}=9999     #纵向滚动条距离上边的值
    ...            ${sleep_time}=0.2
	
    #usage example:
    #Operate Scroll Bar    locator=${locator_vars}[任务_table_滚动条]    type=H    h_value=800
    #Operate Scroll Bar    locator=${locator_vars}[任务_table_滚动条]    type=HV    h_value=9999    v_value=9999
	
    Log    scroll bar locator: ${locator}
    Log    scroll bar type: ${type}
    Log    scroll bar h_value: ${h_value}
    Log    scroll bar v_value: ${v_value}
    Log    =======================================================================

    Sleep    ${sleep_time}	
    Run Keyword If    '${type}' == 'H'     Execute Javascript    document.querySelector("${locator}").scrollLeft=${h_value}
    ...    ELSE IF    '${type}' == 'V'     Execute Javascript    document.querySelector("${locator}").scrollTop=${v_value}
    ...    ELSE IF    '${type}' == 'HV'    Execute Javascript    document.querySelector("${locator}").scrollTo(${h_value},${v_value})
    
Input Text And Search
    [Documentation]    根据文本内容进行搜索
    [Arguments]    ${input_locator}               #Mandatory parameters,请给input box的locator
    ...            ${input_content}               #Mandatory parameters,请给input box的data
    ...            ${search_locator}=${None}      #请给搜索的locator
    ...            ${sleep_time}=0.2
	
    #usage example:
    #Input Text And Search    input_locator=${locator_vars}[任务_输入框]    input_content=test    search_locator=${locator_vars}[任务_输入框后搜索]

    Log    input_locator is: ${input_locator}
    Log    search_locator is: ${search_locator}
    Log    =======================================================================


    Input Text    ${input_locator}    ${input_content}      #在输入框中输入查询内容
    Sleep    ${sleep_time}
    Run Keyword If    '${search_locator}' is not '${None}'    Click Element    ${search_locator}

Get Dropdown List Content
    [Documentation]    得到下拉列表里文本内容
    [Arguments]    ${dl_locator}               #Mandatory parameters,请给下拉框上半部分的locator
    ...            ${dl_content_locator}       #Mandatory parameters,请给下拉框下半部分文本部分的整体locator
    ...            ${sleep_time}=0.5
    [Return]       ${result}         #返回的是string

    #usage example:
    #${result}    Get Dropdown List Content    dl_locator=${locator_vars}[任务_话术模板_选中]    dl_content_locator=${locator_vars}[任务_话术模板_下拉框中文本显示部分]
	
    Log    dropdown list locator: ${dl_locator}
    Log    dropdown list content locator: ${dl_content_locator}
    Log    =======================================================================
	 
    Click Element    ${dl_locator}
    Sleep    ${sleep_time}
    ${result}    Get Text    ${dl_content_locator}
	Log    ${result}
	
	
Check Items Exist Or Not In String
    [Documentation]    在string里检查items数据是否存在
    [Arguments]    ${all_data}                #Mandatory parameters,请传入string
    ...            ${check_items}             #Mandatory parameters, 如果多于一个请传入list
    ...            ${exist}=${True}           #{True}表示存在，{False}表示不存在
    ...            ${sleep_time}=0.2
	
    #usage example:
    #@{my_list}    Create List    接口    test
    #Check Items Exist Or Not In String    all_data=${result}    check_items=${my_list}

    Log    all_data is: ${all_data}
    Log    check_items is: ${check_items}
    Log    exist is: ${True}
    Log    =======================================================================
	
    @{check_items} =   Run Keyword If    isinstance($check_items,list)     Copy List      ${check_items}
    ...          ELSE                                        Create List    ${check_items}	
	
    FOR    ${item}    IN    @{check_items}
         Run Keyword If    ${exist}    Should Contain    ${all_data}    ${item}
         ...      ELSE    Should Not Contain    ${all_data}    ${item}   		 
    END
Check Items Match Or Not In List
    [Documentation]    在list里检查items数据是否精确匹配
    [Arguments]    ${all_data}                #Mandatory parameters,仅支持传入list，用于精确匹配
    ...            ${check_items}             #Mandatory parameters, 如果多于一个请传入list
    ...            ${match}=${True}           #{True}表示精确匹配，{False}表示不匹配
    ...            ${sleep_time}=0.2

    #usage example:
    #@{my_list}    Create List    yao
    #Check Items Match Or Not In List    all_data=${column_data}    check_items=${my_list}    match=${False}
    #Check Items Match Or Not In List    all_data=${column_data}    check_items=${my_list}    match=${True}

    Log    all_data is: ${all_data}
    Log    check_items is: ${check_items}
    Log    exist is: ${True}
    Log    =======================================================================

    @{all_data} =   Run Keyword If    isinstance($all_data,list)     Copy List      ${all_data}
    ...          ELSE                                        Create List    ${all_data}

    @{check_items} =   Run Keyword If    isinstance($check_items,list)     Copy List      ${check_items}
    ...          ELSE                                        Create List    ${check_items}

    ${action}    Set Variable If    ${match}==${True}    ==
                 ...   ${match}==${False}    !=
    Log           ${action}

    FOR    ${item}    IN    @{check_items}
             FOR    ${sub_data}    IN    @{all_dat
                     Run Keyword If    '${item}' ${action} '${sub_data}'    Exit For Loop
         END
    END
Check Items Exist Or Not In List
    [Documentation]    在list里检查items数据是否存在
    [Arguments]    ${all_data}                #Mandatory parameters,仅支持传入list，用于精确匹配或模糊匹配  
    ...            ${check_items}             #Mandatory parameters, 如果多于一个请传入list
    ...            ${exist}=${True}           #{True}表示存在，{False}表示不存在
    ...            ${sleep_time}=0.2
	
    #usage example:
    #@{my_list}    Create List    yao
    #Check Items Exist Or Not In List    all_data=${column_data}    check_items=${my_list}    exist=${False}
    #Check Items Exist Or Not In List    all_data=${column_data}    check_items=${my_list}    exist=${True}

    Log    all_data is: ${all_data}
    Log    check_items is: ${check_items}
    Log    exist is: ${True}
    Log    =======================================================================
	
    @{all_data} =   Run Keyword If    isinstance($all_data,list)     Copy List      ${all_data}
    ...          ELSE                                        Create List    ${all_data}	
	
    @{check_items} =   Run Keyword If    isinstance($check_items,list)     Copy List      ${check_items}
    ...          ELSE                                        Create List    ${check_items}	
	
    ${action}    Set Variable If    ${exist}==${True}    not in
                 ...   ${exist}==${False}    in
    Log   	${action}			 
	
    FOR    ${item}    IN    @{check_items}
	     FOR    ${sub_data}    IN    @{all_data}
		     Run Keyword If    '${item}' ${action} '${sub_data}'    Fail    this's not expected result
         END 		 
    END
	
Check Whether Items are selected In Dropdown List
    [Documentation]    检查某项或某些项在下拉框中是否已选中或未选中
    [Arguments]    ${dl_title_locator}                    #Mandatory parameters,下拉框上部分title的locator, 例如"全部" "创建人账号"等等
    ...            ${check_items}                         #Mandatory parameters,多个时需传入一个list
    ...            ${title_attribute_name}=${None}        #标题文本从哪个属性中提取,请根据源码实际情况选择是否给此值,如果此项为空,表示从标签对中取文本
    ...            ${selected}=${True}                    #${True}表示被选，${False}表示没被选
    ...            ${sleep_time}=0.2
    
    #usage example:    
    #Check Whether Items are selected In Dropdown List    dl_title_locator=${locator_vars}[任务_创建人账号_标题]    check_items=${my_items}    selected=${False}
	
    Log    dl_title_locator is: ${dl_title_locator}
    Log    check_items is: ${check_items}
    Log    title_attribute_name is: ${title_attribute_name}
    Log    selected is: ${selected}
    Log    =======================================================================
	
    @{check_items} =   Run Keyword If    isinstance($check_items,list)     Copy List      ${check_items}
    ...          ELSE                                        Create List    ${check_items}
	
    #${getting_title}    Get Element Attribute    ${dl_title_locator}    ${title_attribute_name}
    ${getting_title}    Run Keyword If    '${title_attribute_name}' is not '${None}'    Get Element Attribute    ${dl_title_locator}    ${title_attribute_name}
                        ...      ELSE    Get Text    ${dl_title_locator}
    Log    ${getting_title}
	
	FOR    ${item}    IN    @{check_items}
        Run Keyword If    ${selected}    Should Contain    ${getting_title}    ${item}
        ...       ELSE    Should Not Contain    ${getting_title}    ${item}
    END

Execute Click Operation For List Exist Items
    [Documentation]    对于list存在项执行click操作
    [Arguments]    ${basic_locator}                 #Mandatory parameters,给出这些项基本的存在位置
    ...            ${append_locator}                #Mandatory parameters,操作项locator,如果多于一个请传入list
    ...            ${commit_locator}=${None}        #提交按钮位置, 如果有提交按钮, 请提供此位置
    ...            ${dl_locator}=${None}            #下拉框选中, 如果没有提交按钮, 请提供此位置, 目的是关闭下拉框, 否则无法后续操作
    ...            ${sleep_time}=0.2
	    
    #usage example:
    #Execute Click Operation For List Exist Items    basic_locator=${locator_vars}[任务_话术模板_下拉框中文本显示部分]    append_locator=${locator_vars}[任务_话术模板_追加list]

    Log    basic_locator is: ${basic_locator}
    Log    append_locator is: ${append_locator}
    Log    commit_locator is: ${commit_locator}
    Log    dl_locator is: ${dl_locator}
    Log    =======================================================================
	
    @{append_locator} =   Run Keyword If    isinstance($append_locator,list)     Copy List      ${append_locator}
    ...          ELSE                                        Create List    ${append_locator}	

    FOR    ${item_locator}    IN    @{append_locator}
        Log    ${item_locator}
#        ${final_locator}    Catenate    SEPARATOR=    ${basic_locator}    ${item_locator}
#        Log    ${final_locator}
#        Click Element    ${final_locator}
        Click Element    ${item_locator}
        Sleep    ${sleep_time}
    END
	
    Sleep    ${sleep_time}
    Run Keyword If    '${commit_locator}' is not '${None}'    Click Element    ${commit_locator}      #提交
    ...    ELSE IF    '${dl_locator}' is not '${None}'    Click Element    ${dl_locator}              #点击下拉框选中, 为了让下拉框关闭

Execute Action By Element Attribute
    [Documentation]    根据属性值来判断是否执行相应的操作
    [Arguments]    ${locator}                   #Mandatory parameters,元素的位置
    ...            ${attribute_name}            #Mandatory parameters,元素的属性名称
    ...            ${attribute_value}           #Mandatory parameters,期望的属性值
    ...            ${click_object}=Element      #Button, Element, Link
    ...            ${sleep_time}=0.1
	
    #usage example:
    #Execute Action By Element Attribute
    #...    locator=//*[@id="templateFlow"]
    #...    attribute_name=class
    #...    attribute_value=zc-j-switch active
	
    Log    locator is: ${locator}
    Log    attribute name is: ${attribute_name}
    Log    attribute value is: ${attribute_value}
    Log    click object is: ${click_object}
    Log    =======================================================================
	
    Sleep    ${sleep_time}
    ${get_attr}    Get Element Attribute    ${locator}    ${attribute_name}
    Run Keyword If    '${get_attr}' != '${attribute_value}'    Click ${click_object}    ${locator}

Input Text And Check Result
    [Documentation]    输入文本后check输入的文本是否存在
    [Arguments]    ${inputbox_locator}                          #Mandatory parameters,提示框界面的action按钮locator,例如"确定"、"删除"等
    ...            ${enter_inputbox_page_locator}=${None}       #点击它进入到输入界面的locator,例如"创建模板"等
    ...            ${input_text}=test                           #输入的文本信息
    ...            ${commit_button_locator}=${None}             #提交按钮locator,例如："提交"、"确定"等
    ...            ${error_info}=已经存在
    ...            ${click_object}=Element                      #Button, Element, Link
    ...            ${sleep_time}=0.3
	
    #usage example:
    #Input Text And Check Result
    #...    enter_inputbox_page_locator=${locator_vars}[话术模板_我的模板_创建模板]
    #...    inputbox_locator=${locator_vars}[话术模板_我的模板_创建模板_模板名称]
    #...    input_text=mytest
    #...    commit_button_locator=${locator_vars}[话术模板_我的模板_创建模板_确定]
	
    Log    enter inputbox page locator is: ${enter_inputbox_page_locator}
    Log    inputbox locator is: ${inputbox_locator}
    Log    input text is: ${input_text}
    Log    commit button locator is: ${commit_button_locator}
    Log    error info is: ${error_info}
    Log    click object is: ${click_object}
    Log    =======================================================================
	
    Sleep    ${sleep_time}
    Run Keyword If    '${enter_inputbox_page_locator}' is not '${None}'    Click ${click_object}    ${enter_inputbox_page_locator}	
    Sleep    ${sleep_time}
    Input Text    ${inputbox_locator}    ${input_text}
    Sleep    ${sleep_time}
    Run Keyword If    '${commit_button_locator}' is not '${None}'    Click ${click_object}    ${commit_button_locator}
	
    ${result}    Get Text    //body
    Log    ${result}
	
    Run Keyword If    '${error_info}' in '''${result}'''    Fail    input text info already exist, so add failed, please double check
	
Check Flash Prompt Message
    [Documentation]    check三秒提示信息是否是预期值
    [Arguments]    ${flash_prompt_locator}            #Mandatory parameters,快闪提示长方形locator
    ...            ${textlink_locator}=${None}        #文本link的locator,例如"删除"
    ...            ${button_locator}=${None}          #提示框界面的action按钮locator,例如"确定"或"删除"等
    ...            ${excepted_message}=成功
    ...            ${click_object}=Element        #Button, Element, Link
    ...            ${sleep_time}=0.3
	
    #usage example:
    #Check Flash Prompt Message
    #...    flash_prompt_locator=xpath=//*[@id="toast-container"]
    #...    excepted_message=成功
	
    Log    textlink locator is: ${textlink_locator}
    Log    button locator is: ${button_locator}
    Log    flash prompt locator is: ${flash_prompt_locator}
    Log    excepted message is: ${excepted_message}
    Log    click object is: ${click_object}
    Log    =======================================================================
	
    ${final_message}    Set Variable

    Sleep    ${sleep_time}
    Run Keyword If    '${textlink_locator}' is not '${None}'    Click ${click_object}    ${textlink_locator}
    Sleep    ${sleep_time}
    Run Keyword If    '${button_locator}' is not '${None}'    Click ${click_object}    ${button_locator}

    Sleep    ${sleep_time}
    ${result}    Get Text    ${flash_prompt_locator}
    @{response}    Split To Lines    ${result}
	
    FOR    ${item}    IN    @{response}
        ${final_message}    Catenate    ${final_message}    ${item}
    END
    Log    ${final_message}

    Run Keyword If    '${excepted_message}' not in '${final_message}'    Fail    check flash prompt message failed
	
Fetch TemplateId
    [Documentation]    获取templated ID
    [Arguments]    ${basic_url}=http://82.156.243.104:8000/api/6.0.0/
    ...            ${companyId}=companyid_value
    ...            ${headers}=header_value
    [return]    ${get_templateId}
	
    #usage example:
    #${headers}    Create Dictionary    Authorization=Bearer ${get_token}
    #@{get_templateId}    Fetch TemplateId    basic_url=http://82.156.243.104:8000/api/6.0.0/    companyId=${get_companyId}    headers=${headers}
	
    Log    ${basic_url}
    Log    ${companyId}
    Log    ${headers}	
    Log    =======================================================================
	
    ${templateId}    Get Json TemplateId Response    basic_url=${basic_url}    companyId=${companyId}    headers=${headers}
    Log    ${templateId}
    ${get_message}    Get Value From Json    ${templateId}    $..message
    ${get_code}    Get Value From Json    ${templateId}    $..code
    ${get_templateId}    Get Value From Json    ${templateId}    $..templateId
    Log    ${get_templateId}
					  
Get Table Data For Line Or Current Page
    [Documentation]    取得table指定行或当前页数据
    [Arguments]    ${tbody_locator}                #Mandatory parameters,请给table下tbody的locator
    ...            ${line}=${None}                 #如果想得到第三行数据,输入3即可
    ...            ${new_console}=${True}          #新控件第一行为空,需要删除掉,如果是老控件,请给${False}
    ...            ${sleep_time}=2
    [Return]       ${table_data}                   #返回的是一个list
	
    #usage example:
    #${data}    Get Table Data For Line Or Current Page    tbody_locator=${locator_vars}[任务_table_tbody]
    #${data}    Get Table Data For Line Or Current Page    line=3    tbody_locator=${locator_vars}[任务_table_tbody]

    Log    table tbdoy locator: ${tbody_locator}
    Log    specified line: ${line}
    Log    =======================================================================
	
    ${table_data}    Create List
	
    ${get_data}    Run Keyword If    '${line}' is not '${None}'    Get Text    ${tbody_locator}/tr[${line}]
                   ...    ELSE    Get Text    ${tbody_locator}
				   
    ${get_data}    Set Variable If    ${new_console}==${True} and '${line}' is '${None}'    Get Slice From List    ${get_data}    1		   

    @{data_list}    Split String    ${get_data}    \n
    ${num}    Get Length    ${data_list}
    FOR    ${i}    IN RANGE    0    ${num}
        Log    ${data_list}[${i}]
        Append To List    ${table_data}    ${data_list}[${i}]       
    END	

    Log    ${table_data}

Check Table Data For Null
    [Documentation]    检查表数据是否为空
    [Arguments]    ${tbody_locator}               #Mandatory parameters,请给table下tbody的locator
    ...            ${null_mark}=暂无数据
    ...            ${sleep_time}=1
    
    #usage example:
    #${data}    Check Table Data For Null
    #...    tbody_locator=${locator_vars}[任务_table_tbody]
    
    Log    tbody_locator is: ${tbody_locator}
    Log    =======================================================================
    
    Sleep    ${sleep_time}
    ${page_line}    Get Table Current Page Line Number    tbody_locator=${tbody_locator}
    ${page_data}    Get Text    ${tbody_locator}
	
    Run Keyword If    ${page_line}==0 and '''${page_data}'''=='${Empty}'        Log    table data is expected null result
    ...    ELSE IF    ${page_line}==1 and '''${page_data}'''=='${null_mark}'    Log    table data is expected null result
    ...       ELSE    Fail    table data isn't null
	
Check Whether Search Getting Table Data Match Column Value
    [Documentation]    检查通过搜索得到的表数据是否match列值 
    [Arguments]    ${column1_list}       #Mandatory parameters,所需的第一列数据
    ...            ${column2_list}       #Mandatory parameters,所需的第二列数据
    ...            ${search_item}         #Mandatory parameters,搜索项
    ...            ${sleep_time}=0.2
	
    #usage example:
    #Check Whether Search Getting Table Data Match Column Value    column1_list=${listDataName}    column2_list=${listDataNumber}    search_item=3

    Log    column1_list is: ${column1_list}
    Log    column2_list is: ${column2_list}
    Log    search_item is: ${search_item}
    Log    =======================================================================
    
    ${column1_len}    Get Length    ${column1_list}
    ${column2_len}    Get Length    ${column2_list}
    
    Should Be Equal As Integers    ${column1_len}    ${column2_len}
	
    FOR    ${i}    IN RANGE    0    ${column1_len}
        Log    ${column1_list}[${i}]
        Log    ${column2_list}[${i}]
        Run Keyword If    '${search_item}' not in '${column1_list}[${i}]' and '${search_item}' not in '${column2_list}[${i}]'    Fail    data can't match search item, please double check!
    END

Get Table Data For All
    [Documentation]    取得table全部数据
    [Arguments]    ${tbody_locator}               #Mandatory parameters,请给table下tbody的locator
    ...            ${right_arrow_locator}         #Mandatory parameters,翻页右键头, table脚下>的locator
    ...            ${new_console}=${True}         #新控件第一行为空,需要删除掉,如果是老控件,请给${False}
    ...            ${click_object}=Element        #Button, Element, Link
    ...            ${sleep_time}=2
    [Return]       ${table_all_data}       #返回的是一个list
	
    #usage example:
    #${data}    Get Table Data For All
    #...    tbody_locator=${locator_vars}[任务_table_tbody]
    #...    right_arrow_locator=${locator_vars}[任务_table_右键头]
    
    Log    tbody_locator: ${tbody_locator}
    Log    right_arrow_locator: ${right_arrow_locator}
    Log    new_console: ${new_console}
    Log    =======================================================================

    ${table_all_data}    Create List

    ${page_line}    Get Table Current Page Line Number    tbody_locator=${tbody_locator}
    ${total_line}    Get Table Total Line Number    tbody_locator=${tbody_locator}
	
    ${page_number}    Evaluate    ${total_line}/${page_line}
	
    Convert To Integer    ${page_number}
    ${loop_number}    Evaluate    ${page_number} + 1
    Log    ${loop_number}
	
    FOR    ${i}    IN RANGE    1    ${loop_number}
        ${page_data}    Get Text    ${tbody_locator}               #得到当前页数据
        @{new_page_list}    Split To Lines    ${page_data}
        Log    ${new_page_list}
		
        ${new_page_list}    Set Variable If    ${new_console}==${True}    Get Slice From List    ${new_page_list}    1	
        
        ${num}    Get Length    ${new_page_list}
        FOR    ${j}    IN RANGE    0    ${num}
            Log    ${new_page_list}[${j}]
            Append To List    ${table_all_data}    ${new_page_list}[${j}]       
        END
        
        Run Keyword If    ${i} < ${page_number}    Click ${click_object}    ${right_arrow_locator}    #点击键头进入下一页
        Sleep    ${sleep_time}		
    END
	
    Log   ${table_all_data}
	
Get Table Column Number
    [Documentation]    取得table总列数
    [Arguments]    ${table_head_locator}       #Mandatory parameters,请给table下表头行tr级的locator,例如：//*[@id="autotest_table_table_thead"]/tr
	...            ${append_locator}=th
	...            ${sleep_time}=1
    [Return]       ${column_number}
	
    #usage example:
	#${column_number}    Get Table Column Number    table_head_locator=//*[@id="autotest_table_table_thead"]/tr    append_locator=th

    Log    table_head_locator: ${table_head_locator}
    Log    =======================================================================
	
    Sleep    ${sleep_time}
    ${final_locator}    Catenate    SEPARATOR=    ${table_head_locator}/    ${append_locator}
    Log    ${final_locator}
    ${column_number}    Get Element Count    ${final_locator}
    Log    ${column_number}
	
Get Table Data For Column
    [Documentation]    取得table列数据
    [Arguments]    ${tbody_locator}                   #Mandatory parameters,请给table下tbody的locator
    ...            ${column}=1                        #如果想得到第三列数据,输入3即可
    ...            ${right_arrow_locator}=${None}     #翻页右键头, table脚下>的locator,如果需要取当前页以外的数据需要提供此位置, 如果不传该参数，只取当前页的列值
    ...            ${new_console}=${True}             #新控件第一行为空,需要删除掉,如果是老控件,请给${False}
    ...            ${the_first_page_locator}=${None}  #请给翻页码中第1页位置
    ...            ${sleep_time}=2
    [Return]       ${column_data}      #返回的是一个list
	
    #usage example:
 	#${column_data}    Get Table Data For Column    tbody_locator=${locator_vars}[任务_table_tbody]    column=9    right_arrow_locator=${locator_vars}[任务_table_右键头]
 	#${column_data}    Get Table Data For Column    tbody_locator=${locator_vars}[任务_table_tbody]    column=2    right_arrow_locator=${locator_vars}[任务_table_右键头]    remove_first_null_value_from_result=${False}
    
    Log    tbody_locator is: ${tbody_locator}
    Log    column is: ${column}
    Log    right_arrow_locator is: ${right_arrow_locator}
    Log    the_first_page_locator is: ${the_first_page_locator}
    Log    new_console is: ${new_console}
    Log    =======================================================================

    Sleep    ${sleep_time}
    ${column_data}    Create List

    Run Keyword If    '${the_first_page_locator}' is not '${None}'    Click Element    ${the_first_page_locator}
	
    ${page_line}    Get Table Current Page Line Number    tbody_locator=${tbody_locator}	
    ${total_line}    Get Table Total Line Number    tbody_locator=${tbody_locator}
	
    ${page_number}    Evaluate    ${total_line}/${page_line}
    ${page_number_new}    Convert To Integer    ${page_number}
	
    ${times_1}    Evaluate    ${page_number_new} + 1
    ${times_2}    Evaluate    ${page_number_new} + 2
	
    ${loop_number}    Set Variable If    ${page_number_new} == ${page_number}    ${times_1}
                      ...    ${page_number_new} < ${page_number}    ${times_2}
			
    ${loop_number}    Set Variable If    '${right_arrow_locator}' is '${None}'    2
                      ...    '${right_arrow_locator}' is not '${None}'    ${loop_number}
					  			  
    ${line_start_number}    Set Variable If    ${new_console}==${True}    2
                            ...        ${new_console}==${False}    1
	
    FOR    ${i}    IN RANGE    1    ${loop_number}
        ${page_line}    Get Table Current Page Line Number    tbody_locator=${tbody_locator}
        ${page_old_console_line}    Evaluate    ${page_line} + 1
	    ${page_new_console_line}    Evaluate    ${page_line} + 2
		
        ${page_line}    Set Variable If    ${new_console}==${True}    ${page_new_console_line}
                                ...        ${new_console}==${False}    ${page_old_console_line}
		
        FOR    ${line}    IN RANGE    ${line_start_number}    ${page_line}
            ${cell_data}    Get Text    ${tbody_locator}/tr[${line}]/td[${column}]            #得到此行此列数据
            Log    ${cell_data}
            Append To List    ${column_data}    ${cell_data}
        END			
        
        Run Keyword If    '${right_arrow_locator}' is not '${None}' and ${i} < ${page_number}    Click Element    ${right_arrow_locator}    #点击键头进入下一页
        Sleep    ${sleep_time}		
    END
	
    Log   ${column_data}

	
Get Table Current Page Line Number
    [Documentation]    取得table当前页行数
    [Arguments]    ${tbody_locator}            #Mandatory parameters,请给table下tbody的locator,因下面会用到${tbody_locator}/tr, 所以${tbody_locator}请给xpath格式
    ...            ${new_console}=${True}      #新控件第一行为空,需要删除掉,如果是老控件,请给${False}
    ...            ${sleep_time}=2
    [Return]       ${line_number}
	
    #usage example:
    #${page_line}    Get Table Current Page Line Number    tbody_locator=${tbody_locator}

    Log    table tbdoy locator: ${tbody_locator}
    Log    new_console is: ${new_console}
    Log    =======================================================================
	
    Sleep    ${sleep_time}
    ${line_number}    Get Element Count    ${tbody_locator}/tr
    ${temp_page_line}    Evaluate    ${line_number} - 1

    ${line_number}    Set Variable If    ${new_console}==${True}    ${temp_page_line}
                            ...        ${new_console}==${False}    ${line_number}

Get Table Total Line Number
    [Documentation]    取得table总行数
    [Arguments]    ${sleep_time}=2            
    [Return]       ${line_number}
	
    #usage example:
    #${total_line}    Get Table Total Line Number    tbody_locator=${tbody_locator}
    Log    =======================================================================
	
    ${result}    Get Text    //body
    Log    ${result}
    ${match_result}    ${line_number}    Should Match Regexp    ${result}    (?is)共\\s+(\\d+)\\s+条
    Log    ==> get item number is ${line_number}
	
Select All Or Cancel All In Dropdown List By Title
    [Documentation]    通过标题全选或者全取消下拉列表里的所有项
    [Arguments]    ${dl_locator}                          #Mandatory parameters,下拉框选中位置
    ...            ${dl_title_locator}                    #Mandatory parameters,下拉框上部分title的locator, 例如"全部" "创建人账号"等等
    ...            ${title_content}                       #Mandatory parameters,期望出现的title内容
    ...            ${all_locator}                         #Mandatory parameters,"全部"或"全选"或其他表示全选位置的locator
    ...            ${title_attribute_name}=${None}        #标题文本从哪个属性中提取,请根据源码实际情况选择是否给此值,如果此项为空,表示从标签对中取文本
    ...            ${commit_locator}=${None}              #"确定"或"提交"按钮的locator
    ...            ${sleep_time}=0.5

    #usage example:
    #Select All Or Cancel All In Dropdown List By Title
    #...    dl_locator=${locator_vars}[任务_创建人账号_选中]          
    #...    dl_title_locator=${locator_vars}[任务_创建人账号_标题]
    #...    title_content=全部       
    #...    all_locator=${locator_vars}[任务_创建人账号_全部]
    #...    commit_locator=${locator_vars}[任务_创建人账号_确定] 

    Log    dl_locator is: ${dl_locator}
    Log    dl_title_locator is: ${dl_title_locator}
    Log    title_content is: ${title_content}
    Log    all_locator is: ${all_locator}
    Log    title_attribute_name is: ${title_attribute_name}
    Log    commit_locator is: ${commit_locator}
    Log    =======================================================================
		
    FOR    ${i}    IN RANGE    2
        #${getting_title}    Get Element Attribute    ${dl_title_locator}    ${title_attribute_name}
        ${getting_title}    Run Keyword If    '${title_attribute_name}' is not '${None}'    Get Element Attribute    ${dl_title_locator}    ${title_attribute_name}
                            ...      ELSE    Get Text    ${dl_title_locator}
	    Run Keyword If    '${getting_title}' != '${title_content}'    Select Mutiple Items From Dropdown List    dl_locator=${dl_locator}    items_locator=${all_locator}    commit_locator=${commit_locator}
        ...       ELSE    Exit For Loop
	END

Select Single Item From Dropdown List
    [Documentation]    从内容不变的下拉列表中选择一项内容
    [Arguments]    ${dl_locator}                 #Mandatory parameters,下拉框选中位置
    ...            ${item_locator}               #Mandatory parameters,选择项位置
    ...            ${input_locator}=${None}      #输入框位置
    ...            ${input_content}=${None}      #查询内容，特别说明：尽量不用这种方式，如果要用这种方式，一定要输入完整项，不能只输入部分，因为有些页面上输入部分后源代码中文本会分成二部分，导致匹配不上
    ...            ${sleep_time}=0.2

    #usage example:	
    #Select Single Item From Dropdown List    dl_locator=${locator_vars}[呼叫方向_下拉框选中]    item_locator=${locator_vars}[呼叫方向_呼出]
    #Select Single Item From Dropdown List    dl_locator=${locator_vars}[任务_话术模板_选中]    item_locator=${locator_vars}[任务_话术模板_tts按键]    input_locator=${locator_vars}[任务_话术模板_搜索]    input_content=${locator_vars}[任务_话术模板_搜索输入内容]

    Log    dropdown list locator is: ${dl_locator}
    Log    input locator is: ${input_locator}
    Log    input content is: ${input_content}
    Log    the item to be selected is: ${item_locator}
    Log    =======================================================================
	
    Click Element    ${dl_locator}
    Sleep    ${sleep_time}
	
    Run Keyword If    '${input_locator}' is not '${None}' and '${input_content}' is not '${None}'    Input Text    ${input_locator}    ${input_content}      #在输入框中输入查询内容
    Sleep    ${sleep_time}
	
    Click Element    ${item_locator}
	
Write Vars Into File
    [Documentation]    把变量写入文件
    [Arguments]    ${vars}=vars
    ...            ${file}=file_with_vars.txt

    Create File  ${EXECDIR}/${file}  ${vars}

Get Vars From File
    [Documentation]    从文件里得到变量
    [Arguments]    ${file}=file
    [Return]       ${contents}

    ${contents}=  Get File  ${EXECDIR}/${file}
	
Upload Local File
    [Documentation]    上传文件
    [Arguments]    ${batch_import_button_locator}       #Mandatory parameters,批量导入按钮locator
    ...            ${check_info}                        #Mandatory parameters,通过文本判断是否进入预期页面
    ...            ${upload_button_locator}             #Mandatory parameters,上传文件的locator
    ...            ${file}                              #Mandatory parameters,上传的文件可以是一个,也可以是多个,如果是多个请传入文件list
    ...            ${import_button_locator}             #Mandatory parameters,导入按钮的locator
    ...            ${check_info_2}                      #Mandatory parameters,通过文本判断是否进入预期页面
    ...            ${confirm_button_locator}            #Mandatory parameters,确认按钮的locator
    ...            ${sleep_time}=0.5
	
    Log    =======================================================================
    @{file} =   Run Keyword If    isinstance($file,list)     Copy List      ${file}
    ...          ELSE                                        Create List    ${file}
	
    Log    批量导入的位置是: ${batch_import_button_locator}
    Log    上传文件的位置是：${upload_button_locator}
    Log    上传的文件是: ${file}
    Log    导入按钮的位置是：${import_button_locator}
    Log    确认按钮的位置是：${confirm_button_locator}

    FOR    ${index}    IN    @{file}
        Sleep    ${sleep_time}
        Click Element    ${batch_import_button_locator}               #选中"批量导入"
        Wait Until Page Contains    ${check_info}    60s              #等待导入界面出现并确认信息
        choose file     ${upload_button_locator}    ${index}          #输入需要上传的文件
        Sleep    ${sleep_time}
        Capture Page Screenshot
        Click Element    ${import_button_locator}                     #点击导入按钮
        Wait Until Page Contains    ${check_info_2}    60s
        Sleep    ${sleep_time}
        Click Element    ${confirm_button_locator}                    #点击确认按钮
        Sleep    ${sleep_time}
    END

Write Url And Session Into File
    [Documentation]    得到url和session id并写入文件
    [Arguments]    ${file}=file_with_vars.txt

    ${conn_url}    ${session_id}=    Return Driver Props
    Write Vars Into File    vars=${conn_url},${session_id}    file=${file}
	
Debug Mode
    [Documentation]    Debug Mode
    [Arguments]    ${file}=file_with_vars.txt
    ...            ${browser}=chrome
	
    ${vars_content}=    Get Vars From File    file=${file}
    @{items} =    Split String    ${vars_content}    ,
    Log    conn_url is : ${items}[0]
    Log    session_id is : ${items}[1]
    Open Browser    about:about     remote_url=${items}[0]   browser=${browser}
    Set Driver Session ID    ${items}[1]
	
Clear Text Information
    [Documentation]    删除已存在的文本信息
    [Arguments]    ${locator}     #Mandatory parameters，清除位置的locator
    ...            ${count}=10    #退格的次数，退格一次删除一个字符
    Log    =======================================================================
	
    Log    input locator is : ${locator}
	
    FOR    ${index}    IN RANGE    0    ${count}
        Press Keys    ${locator}    \ue003
    END
	
Select Mutiple Items From Dropdown List
    [Documentation]    从内容不可变的下拉列表中选择一项或多项内容
    [Arguments]    ${dl_locator}                  #Mandatory parameters,下拉框位置
    ...            ${items_locator}               #Mandatory parameters,选择项位置,如果多于一个请传入list
    ...            ${input_locator}=${None}       #输入框位置
    ...            ${input_content}=${None}       #查询内容
    ...            ${commit_locator}=${None}      #提交按钮位置
    ...            ${sleep_time}=0.3

    #usage example:	
    #Select Mutiple Items From Dropdown List    dl_locator=${dl_locator}    items_locator=${all_locator}    commit_locator=${commit_locator}

    Log    下拉框位置: ${dl_locator}
    Log    输入框位置: ${input_locator}
    Log    查询内容: ${input_content}
    Log    选择项位置: ${items_locator}
    Log    提交按钮位置: ${commit_locator}
    Log    =======================================================================
	
    @{items_locator} =   Run Keyword If    isinstance($items_locator,list)     Copy List      ${items_locator}
    ...          ELSE                                        Create List    ${items_locator}
	
    Click Element    ${dl_locator}         #选中多选下拉框
    Sleep    ${sleep_time}
	
    Run Keyword If    '${input_locator}' is not '${None}' and '${input_content}' is not '${None}'    Input Text    ${input_locator}    ${input_content}      #在输入框中输入查询内容
    Sleep    ${sleep_time}
	
    FOR    ${item}    IN    @{items_locator}      #选择所选项
        Click Element    ${item}               
    END
    Capture Page Screenshot
	
    Sleep    ${sleep_time}
    Run Keyword If    '${commit_locator}' is not '${None}'    Click Element    ${commit_locator}      #提交
    ...       ELSE    Click Element    ${dl_locator}
	
#Set customized Date Or Time
#    [Documentation]    设置日历的开始日期时间和结束日期时间
#    [Arguments]    ${customize_locator}                 #Mandatory parameters,"自定义"选项位置
#    ...            ${start_locator}                     #Mandatory parameters,开始日期或时间输入位置
#    ...            ${end_locator}                       #Mandatory parameters,结束日期或时间输入位置
#    ...            ${input_start_date_or_time}          #Mandatory parameters,输入开始日期和时间,例如2011-01-01, 2011-01-01 00:00 
#    ...            ${input_end_date_or_time}            #Mandatory parameters,输入结束日期和时间,例如2018-01-01, 2018-01-01 00:00
#    ...            ${commit_button_locator}             #Mandatory parameters,确定按钮位置
#    ...            ${sleep_time}=0.2
#
#    Log    customize_locator is: ${customize_locator}
#    Log    start_locator is: ${start_locator}
#    log    end_locator is: ${end_locator}         
#    log    input_start_date_or_time is: ${input_start_date_or_time}         
#    log    input_end_date_or_time is: ${input_end_date_or_time}
#    log    commit_button_locator is: ${commit_button_locator}
#    Log    =======================================================================
#	
#    Click Element    ${customize_locator}         #点开日历设置
#    Sleep    ${sleep_time}
#    
#    Clear Element Text    ${start_locator}
#    Sleep    ${sleep_time}
#    
#    Click Element    ${start_locator}             #选中开始位置
#    Sleep    ${sleep_time}
#    
#    Input Text    ${start_locator}    ${input_start_date_and_time}          #输入开始日期和时间
#    Sleep    ${sleep_time}
#    
#    Input Text    ${end_locator}    ${input_end_date_and_time}          #输入开始日期和时间
#    Sleep    ${sleep_time}
#    
#    Click Element    ${commit_locator}         #确定提交
	
Set Calendar From Start To End By Input Date And Time
    [Documentation]    设置日历的开始日期时间和结束日期时间
    [Arguments]    ${clear_locator}                     #Mandatory parameters,日期控件清除位置
    ...            ${calendar_locator}                  #Mandatory parameters,日期控件下拉框位置
    ...            ${start_locator}                     #Mandatory parameters,开始日期输入位置
    ...            ${end_locator}                       #Mandatory parameters,结束日期输入位置
    ...            ${input_start_date_and_time}         #Mandatory parameters,输入开始日期和时间,例如2011-01-01 00:00 
    ...            ${input_end_date_and_time}           #Mandatory parameters,输入结束日期和时间,例如2018-01-01 00:00
    ...            ${commit_locator}                    #Mandatory parameters,确定按钮位置
    ...            ${sleep_time}=0.2

    Log    clear_locator is: ${clear_locator}
    Log    calendar_locator is: ${calendar_locator}
    log    start_locator is: ${start_locator}         
    log    end_locator is: ${end_locator}         
    log    input_start_date_and_time is: ${input_start_date_and_time}
    log    input_end_date_and_time is: ${input_end_date_and_time}
    log    commit_locator is: ${commit_locator}
    Log    =======================================================================
	
    Click Element    ${clear_locator}            #清除日历
    Sleep    ${sleep_time}    
	
    Click Element    ${calendar_locator}         #点开日历
    Sleep    ${sleep_time}

    Click Element    ${start_locator}            #选中开始位置
    Sleep    ${sleep_time}
	
    Input Text    ${start_locator}    ${input_start_date_and_time}          #输入开始日期和时间
    Sleep    ${sleep_time}
	
    Input Text    ${end_locator}    ${input_end_date_and_time}          #输入开始日期和时间
    Sleep    ${sleep_time}

    Click Element    ${commit_locator}         #确定提交

Create Task By Curl
    [Documentation]    Create Task By Curl
    [Arguments]    ${curl_path}=C:\\tools
	...            ${protocol}=http
    ...            ${ip}=82.156.243.104:8000
    ...            ${version}=6.0.0
    ...            ${head_Content_Type}=Content-Type:application/json
    ...            ${json_file}=C:\\yaoyao====\\file.json
    ...            ${companyId}=companyidvalue
    ...            ${token}=tokenvalue

    Run    ${curl_path}\\curl.exe -X POST -H "${head_Content_Type}" -H "Authorization:Bearer ${token}" -d "@${json_file}" "${protocol}://${ip}/api/${version}/companies/${companyId}/tasks" > ${curl_path}\\tempfile_task

    ${json}    Get File    ${curl_path}\\tempfile_task
    ${js}    Convert String to JSON    ${json}
    ${get_message}    Get Value From Json    ${js}    $..message
    ${get_code}    Get Value From Json    ${js}    $..code
    Run Keyword If    ${get_code}[0] != 200    Fail    return interface info failed, return code isn't 200, is ${get_code}[0]

Fetch TemplateId By Curl
    [Documentation]    Fetch TemplateId By Curl
    [Arguments]    ${curl_path}=C:\\tools
	...            ${protocol}=http
    ...            ${ip}=82.156.243.104:8000
    ...            ${version}=6.0.0
    ...            ${companyId}=companyidvalue
    ...            ${token}=tokenvalue
    [return]    ${get_templateId}

    Run    ${curl_path}\\curl.exe -X GET -H "Authorization:Bearer ${token}" "${protocol}://${ip}/api/${version}/companies/${companyId}/templates" > ${curl_path}\\tempfile_templateId
    ${json}    Get File    ${curl_path}\\tempfile_templateId
    ${js}    Convert String to JSON    ${json}
    ${get_message}    Get Value From Json    ${js}    $..message
    ${get_code}    Get Value From Json    ${js}    $..code
    Run Keyword If    ${get_code}[0] != 200    Fail    return interface info failed, return code isn't 200, is ${get_code}[0]
    ${get_templateId}    Get Value From Json    ${js}    $..templateId
    Log    ${get_templateId}


Fetch CompanyId By Curl
    [Documentation]    Fetch CompanyId By Curl
    [Arguments]    ${curl_path}=C:\\tools
    ...            ${protocol}=http
    ...            ${ip}=82.156.243.104:8000
    ...            ${version}=6.0.0
    ...            ${head_Content_Type}=Content-Type:application/json
    ...            ${username}=test_user
    ...            ${password}=123456
    [return]    ${get_companyId}[0]

    Run    ${curl_path}\\curl.exe -X GET -H "${head_Content_Type}" --data "{\\"userPassWord\\":\\"${password}\\"}" "${protocol}://${ip}/api/${version}/reference-icall-users/${username}" > ${curl_path}\\tempfile_companyId
    ${json}    Get File    ${curl_path}\\tempfile_companyId
    ${js}    Convert String to JSON    ${json}
    ${get_message}    Get Value From Json    ${js}    $..message
    ${get_code}    Get Value From Json    ${js}    $..code
    Run Keyword If    ${get_code}[0] != 200    Fail    return interface info failed, return code isn't 200, is ${get_code}[0]
    ${get_companyId}    Get Value From Json    ${js}    $..companyId       #${get_companyId} is list, not string

Fetch Token By Curl
    [Documentation]    Fetch Token By Curl
    [Arguments]    ${curl_path}=C:\\tools
    ...            ${protocol}=http
    ...            ${ip}=82.156.243.104:8000
    ...            ${version}=6.0.0
    ...            ${username}=test_user
    [return]    ${get_token}[0]
	
    Run    ${curl_path}\\curl.exe -X GET "${protocol}://${ip}/api/${version}/consumers/${username}" > ${curl_path}\\tempfile_apikey_and_apisecret
    ${json}    Get File    ${curl_path}\\tempfile_apikey_and_apisecret
    ${js}    Convert String to JSON    ${json}
    ${get_message}    Get Value From Json    ${js}    $..message
    ${get_code}    Get Value From Json    ${js}    $..code
    Run Keyword If    ${get_code}[0] != 200    Fail    return interface info failed, return code isn't 200, is ${get_code}[0]
    ${get_apikey}    Get Value From Json    ${js}    $..apiKey
    ${get_apisecret}    Get Value From Json    ${js}    $..apiSecret

    Run    ${curl_path}\\curl.exe -X GET "${protocol}://${ip}/api/${version}/tokens?apiKey=${get_apikey}[0]&apiSecret=${get_apisecret}[0]" > ${curl_path}\\tempfile_token
    ${json}    Get File    ${curl_path}\\tempfile_token
    ${js}    Convert String to JSON    ${json}
    ${get_message}    Get Value From Json    ${js}    $..message
    ${get_code}    Get Value From Json    ${js}    $..code
    Run Keyword If    ${get_code}[0] != 200    Fail    return interface info failed, return code isn't 200, is ${get_code}[0]
    ${get_token}    Get Value From Json    ${js}    $..access_token       #${get_token} is list, not string

